Attribute VB_Name = "Code128"
' VB / VBA Functions for Code128(A, B,C), GS1-128, UCC/EAN 128, SCC-14 and SSCC-18
' Copyright 2012 by MW6 Technologies Inc. All rights reserved.
'
' This code may not be modified or distributed unless you purchase
' the license from MW6.

Private I As Integer
Private StrLen As Integer
Private sum As Long
Private CurrSet As Integer
Private CurrChar As Integer
Private NextChar As Integer
Private Message As String
Private Weight  As Integer

Public Function GS1_128(ByVal Src As String) As String
    Dim tmp As Integer
    Dim CurrDone As Boolean
    Dim prevBracketExist As Boolean
    Dim tmpStr As String
    Dim CharOffset As Integer
    
    On Error GoTo bye:
     
    CharOffset = 0
    StrLen = Len(Src)
    sum = 105
    Weight = 1
    
    ' 3 indicates Set C
    CurrSet = 3
    
    ' start character (203)
    Message = ChrW(203 + CharOffset)
    
    I = 1
    While (I <= StrLen)
        CurrChar = Asc(Mid(Src, I, 1))
        CurrDone = False
        
        If ((I + 1) <= StrLen) Then
            NextChar = Asc(Mid(Src, I + 1, 1))
            
            If (CurrChar >= Asc("0") And CurrChar <= Asc("9") And _
                NextChar >= Asc("0") And NextChar <= Asc("9")) Then
                tmp = (CurrChar - Asc("0")) * 10 + (NextChar - Asc("0"))
                
                ' 2 digits
                If (CurrSet <> 3) Then
                    ' the previous set is not Set C
                    Message = Message & ChrW(99 + 98)
                    sum = sum + Weight * 99
                    Weight = Weight + 1
                    CurrSet = 3
                End If
                
                If (tmp = 0) Then
                    Message = Message & ChrW(192 + CharOffset)
                ElseIf (tmp > 0 And tmp < 95) Then
                    Message = Message & ChrW(tmp + 32)
                Else
                    Message = Message & ChrW(tmp + 98)
                End If
                    
                sum = sum + Weight * tmp
                I = I + 2
                
                CurrDone = True
            End If
        End If
        
        If (CurrChar = Asc("(") And (Not CurrDone)) Then
            Message = Message & ChrW(200 + CharOffset)
            sum = sum + Weight * 102
            prevBracketExist = True
            I = I + 1
            
            CurrDone = True
        End If
        
        If (CurrChar = Asc(")") And prevBracketExist And (Not CurrDone)) Then
            prevBracketExist = False
            I = I + 1
            Weight = Weight - 1
            
            CurrDone = True
        End If
        
        If (Not CurrDone) Then
            If (CurrChar >= 0 And CurrChar <= 31) Then
                ' choose Set A
                If (CurrSet <> 1) Then
                    ' the previous set is not Set A
                    Message = Message & ChrW(101 + 98 + CharOffset)
                    sum = sum + Weight * 101
                    Weight = Weight + 1
                    CurrSet = 1
                End If
                
                If (CurrChar = 31) Then
                    Message = Message & ChrW(193 + CharOffset)
                    sum = sum + Weight * 95
                Else
                    Message = Message & ChrW(CurrChar + 96)
                    sum = sum + Weight * (CurrChar + 64)
                End If
            Else
                ' choose Set B
                If (CurrSet <> 2) Then
                    ' the previous set is not Set B
                    Message = Message & ChrW(100 + 98 + CharOffset)
                    sum = sum + Weight * 100
                    Weight = Weight + 1
                    CurrSet = 2
                End If
                
                If (CurrChar = 32) Then
                    Message = Message & ChrW(192 + CharOffset)
                ElseIf (CurrChar = 127) Then
                    Message = Message & ChrW(193 + CharOffset)
                    sum = sum + Weight * 95
                ElseIf (CurrChar < 127 And CurrChar > 32) Then
                    Message = Message & Chr(CurrChar)
                    sum = sum + Weight * (CurrChar - 32)
                End If
            End If
            
            I = I + 1
        End If
        
        Weight = Weight + 1
    Wend
    
    ' add CheckDigit
    sum = sum Mod 103
    If (sum = 0) Then
        Message = Message & ChrW(192 + CharOffset)
    ElseIf (sum <= 94) Then
        Message = Message & Chr(sum + 32)
    Else
        Message = Message & Chr(sum + 98)
    End If
    
    ' add stop character (204)
    Message = Message & ChrW(204 + CharOffset)
    
    GS1_128 = Message
    Exit Function
    
bye:
    GS1_128 = ""
    
End Function

Public Function Code128Auto(ByVal Src As String) As String
    StrLen = Len(Src)
    sum = 104
    
    ' 2 indicates Set B
    CurrSet = 2
    
    ' start character with value 202 for Set B
    Message = "" & Chr(202)
    
    CurrChar = Asc(Mid(Src, 1, 1))
    If (CurrChar <= 31 And CurrChar >= 0) Then
        ' switch to Set A
        ' 1 indicates Set A
        CurrSet = 1
        
        ' start character with value 201 for Set A
        Message = "" & Chr(201)
        sum = 103
    End If
    
    Weight = 1
    Call GeneralEncode(Src)
    
    Code128Auto = Message
End Function

Public Function UCCEAN128(ByVal Src As String) As String
    StrLen = Len(Src)
    sum = 105
    
    ' 3 indicates Set C
    CurrSet = 3
    
    ' start character (203) + FNC1 (200)
    Message = Chr(203) & Chr(200)
    sum = sum + 102
    Weight = 2
    Call GeneralEncode(Src)
    
    UCCEAN128 = Message
End Function
        
Public Sub GeneralEncode(ByVal Src As String)
    Dim tmp As Integer
    Dim CurrDone As Boolean
    
    I = 1
    While (I <= StrLen)
        CurrChar = Asc(Mid(Src, I, 1))
        CurrDone = False
        If ((I + 1) <= StrLen) Then
            NextChar = Asc(Mid(Src, I + 1, 1))
            
            If (CurrChar >= Asc("0") And CurrChar <= Asc("9") And _
                NextChar >= Asc("0") And NextChar <= Asc("9")) Then
                tmp = (CurrChar - Asc("0")) * 10 + (NextChar - Asc("0"))
                
                ' 2 digits
                If (CurrSet <> 3) Then
                    ' the previous set is not Set C
                    Message = Message & Chr(99 + 98)
                    sum = sum + Weight * 99
                    Weight = Weight + 1
                    CurrSet = 3
                End If
                
                If (tmp = 0) Then
                    Message = Message & Chr(192)
                ElseIf (tmp > 0 And tmp < 95) Then
                    Message = Message & Chr(tmp + 32)
                Else
                    Message = Message & Chr(tmp + 98)
                End If
                    
                sum = sum + Weight * tmp
                I = I + 2
                
                CurrDone = True
            End If
        End If
        
        If (Not CurrDone) Then
            If (CurrChar >= 0 And CurrChar <= 31) Then
                ' choose Set A
                If (CurrSet <> 1) Then
                    ' the previous set is not Set A
                    Message = Message & Chr(101 + 98)
                    sum = sum + Weight * 101
                    Weight = Weight + 1
                    CurrSet = 1
                End If
                
                If (CurrChar = 31) Then
                    Message = Message & Chr(193)
                    sum = sum + Weight * 95
                Else
                    Message = Message & Chr(CurrChar + 96)
                    sum = sum + Weight * (CurrChar + 64)
                End If
            Else
                ' choose Set B
                If (CurrSet <> 2) Then
                    ' the previous set is not Set B
                    Message = Message & Chr(100 + 98)
                    sum = sum + Weight * 100
                    Weight = Weight + 1
                    CurrSet = 2
                End If
                
                If (CurrChar = 32) Then
                    Message = Message & Chr(192)
                ElseIf (CurrChar = 127) Then
                    Message = Message & Chr(193)
                    sum = sum + Weight * 95
                ElseIf (CurrChar < 127 And CurrChar > 32) Then
                    Message = Message & Chr(CurrChar)
                    sum = sum + Weight * (CurrChar - 32)
                End If
            End If
            
            I = I + 1
        End If
        
        Weight = Weight + 1
    Wend
    
    ' add CheckDigit
    sum = sum Mod 103
    If (sum = 0) Then
        Message = Message & Chr(192)
    ElseIf (sum <= 94) Then
        Message = Message & Chr(sum + 32)
    Else
        Message = Message & Chr(sum + 98)
    End If
    
    ' add stop character (204)
    Message = Message & Chr(204)
End Sub

Public Function Code128A(ByVal Src As String) As String
    StrLen = Len(Src)
    sum = 103
    
    ' start character (201) for Set A
    Message = "" & Chr(201)
    
    Weight = 1
    For I = 1 To StrLen
        CurrChar = Asc(Mid(Src, I, 1))
        If (CurrChar = 32) Then
            Message = Message & Chr(192)
        ElseIf (CurrChar = 31) Then
            Message = Message & Chr(193)
            sum = sum + Weight * 95
        ElseIf (CurrChar <= 95 And CurrChar > 32) Then
            Message = Message & Chr(CurrChar)
            sum = sum + Weight * (CurrChar - 32)
        ElseIf (CurrChar >= 0 And CurrChar <= 31) Then
            Message = Message & Chr(CurrChar + 96)
            sum = sum + Weight * (CurrChar + 64)
        Else
            Message = Code128Auto(Src)
            Code128A = Message
            Exit Function
        End If
        Weight = Weight + 1
    Next I
    
    ' add CheckDigit
    sum = sum Mod 103
    If (sum = 0) Then
        Message = Message & Chr(192)
    ElseIf (sum <= 94) Then
        Message = Message & Chr(sum + 32)
    Else
        Message = Message & Chr(sum + 98)
    End If
    
    ' add stop character (204)
    Message = Message & Chr(204)
    
    Code128A = Message
End Function

Public Function Code128B(ByVal Src As String) As String
    StrLen = Len(Src)
    sum = 104
    
    ' start character (202) for Set B
    Message = "" & Chr(202)
    
    Weight = 1
    For I = 1 To StrLen
        CurrChar = Asc(Mid(Src, I, 1))
        If (CurrChar = 32) Then
            Message = Message & Chr(192)
        ElseIf (CurrChar = 127) Then
            Message = Message & Chr(193)
            sum = sum + Weight * 95
        ElseIf (CurrChar < 127 And CurrChar > 32) Then
            Message = Message & Chr(CurrChar)
            sum = sum + Weight * (CurrChar - 32)
        Else
            Message = Code128Auto(Src)
            Code128B = Message
            Exit Function
        End If
        
        Weight = Weight + 1
    Next I
    
    ' add CheckDigit
    sum = sum Mod 103
    If (sum = 0) Then
        Message = Message & Chr(192)
    ElseIf (sum <= 94) Then
        Message = Message & Chr(sum + 32)
    Else
        Message = Message & Chr(sum + 98)
    End If
    
    ' add stop character (204)
    Message = Message & Chr(204)
    
    Code128B = Message
End Function

Public Function Code128C(ByVal Src As String) As String
    Dim tmp As Integer
    
    StrLen = Len(Src)
    sum = 105
    
    ' start character (203) for Set C
    Message = "" & Chr(203)
    
    Weight = 1
    I = 1
    While (I <= StrLen)
        CurrChar = Asc(Mid(Src, I, 1))
        If ((I + 1) <= StrLen) Then
            NextChar = Asc(Mid(Src, I + 1, 1))
            
            If (CurrChar >= Asc("0") And CurrChar <= Asc("9") And _
                NextChar >= Asc("0") And NextChar <= Asc("9")) Then
                '2 digits
                tmp = (CurrChar - Asc("0")) * 10 + (NextChar - Asc("0"))
                
                If (tmp = 0) Then
                    Message = Message & Chr(192)
                ElseIf (tmp > 0 And tmp < 95) Then
                    Message = Message & Chr(tmp + 32)
                Else
                    Message = Message & Chr(tmp + 98)
                End If
                    
                sum = sum + Weight * tmp
                I = I + 2
            Else
                Message = Code128Auto(Src)
                Code128C = Message
                Exit Function
            End If
        Else
            Message = Message & Chr(198)
            sum = sum + Weight * 100
            Weight = Weight + 1
            
            If (CurrChar = 32) Then
                Message = Message & Chr(192)
            ElseIf (CurrChar = 127) Then
                Message = Message & Chr(193)
                sum = sum + Weight * 95
            ElseIf (CurrChar < 127 And CurrChar > 32) Then
                Message = Message & Chr(CurrChar)
                sum = sum + Weight * (CurrChar - 32)
            Else
                Message = Code128Auto(Src)
                Code128C = Message
                Exit Function
            End If
            I = I + 1
        End If
        
        Weight = Weight + 1
    Wend
    
    ' add CheckDigit
    sum = sum Mod 103
    If (sum = 0) Then
        Message = Message & Chr(192)
    ElseIf (sum <= 94) Then
        Message = Message & Chr(sum + 32)
    Else
        Message = Message & Chr(sum + 98)
    End If
    
    ' add stop character (204)
    Message = Message & Chr(204)
    
    Code128C = Message
End Function

Public Function SCC14(ByVal Src As String, ByRef HRStr As String) As String
    Dim tmpStr As String
    
    tmpStr = GetFixedLenString(Src, 14)
    tmpStr = tmpStr & Chr(GetCheckSum(tmpStr) + 48)
    HRStr = "(01)" & tmpStr
    SCC14 = GS1_128(HRStr)
End Function

Public Function SSCC18(ByVal Src As String, ByRef HRStr As String) As String
    Dim tmpStr As String
    
    tmpStr = GetFixedLenString(Src, 17)
    tmpStr = tmpStr & Chr(GetCheckSum(tmpStr) + 48)
    HRStr = "(00)" & tmpStr
    SSCC18 = GS1_128(HRStr)
End Function

' Create a fixed length string
Private Function GetFixedLenString(ByVal Src As String, ByVal FixedLen As Integer) As String
    Dim I As Integer
    Dim tmpStr As String
    Dim count As Integer
    
    count = Len(Src)
    If (count = FixedLen) Then
        GetFixedLenString = Src
        Exit Function
    End If
    
    If (count > FixedLen) Then
        GetFixedLenString = Mid(Src, 1, FixedLen)
        Exit Function
    End If
    
    tmpStr = Src
    For I = 1 To (FixedLen - count)
        tmpStr = "0" & tmpStr
    Next I
    
    GetFixedLenString = tmpStr
End Function

' Create check sum for SCC-14 and SSCC-18 barcodes
Private Function GetCheckSum(ByVal Src As String) As Integer
    Dim sum As Integer
    Dim I As Integer
    Dim count As Integer
    Dim ch As Integer
    
    sum = 0
    count = Len(Src)
    For I = 1 To count
        ch = Asc(Mid(Src, count - I + 1, 1)) - Asc("0")
        sum = sum + ch
        If ((I Mod 2) = 1) Then
            sum = sum + 2 * ch
        End If
    Next I
    
    sum = 10 - (sum Mod 10)
    If (sum = 10) Then
        sum = 0
    End If
    
    GetCheckSum = sum
    
End Function
